<?lsp

local fmt=string.format
local quote=luasql.quotestr
local sqlutil=require"sqlutil"
local conn=conn
local data=bd.rtrim(request:data())
headerdata=[[
<style>
#form{
max-width:350px;
margin:auto;
}
</style>
<script>
$(function() {
      $("#rm").click(function() {
            if($(this).is(':checked'))
            {
               if(confirm("Are you sure you want to remove your email address?"))
                  return;
               $(this).removeAttr('checked');
            }
      });
});
</script>
]]
title="File Mailer Settings"
response:include"/rtl/.EmptyHeader.lsp"
local function emitForm()
   local email,firstname,lastname=sqlutil.find(
      conn, "email,firstname,lastname FROM mailcontact WHERE key="..mailcontactkey)
   
?>
<div id="form" class="roundedbox">
<form method="POST">
<table>
<tr><td>Email:</td><td><?lsp=email?></td></tr>
<tr><td>First&nbsp;Name:</td><td><input type="text" name="firstname" value="<?lsp=firstname?>"></td></tr>
<tr><td>Last&nbsp;Name:</td><td><input type="text" name="lastname" value="<?lsp=lastname?>"></td></tr>
<tr><td><input type="checkbox" id="rm" name="rm"></td><td>Remove email address from database!</td></tr>
</table>
<input type="submit" name="update" value="Update" style="margin-top:10px;padding:5px 15px 5px 15px">
</form>
</div>
<?lsp
end -- emitForm

local function remove()
   local sql=fmt("DELETE FROM mailcontact WHERE key=%s",mailcontactkey)
   require"mailutil".sqlexec(conn,sql)
   print'<h1>Email address removed!</h1><h2><a href="/">Continue</a>'
end

local function updatename()
   local sql=fmt("UPDATE mailcontact SET firstname=%s,lastname=%s WHERE key=%s",
                 quote(data.firstname),quote(data.lastname),mailcontactkey)
   require"mailutil".sqlexec(conn,sql)
   print'<h1>Name updated!</h1><h2><a href="/">Continue</a>'
end

if request:method()=="POST" then
   if data.rm then
      remove()
   elseif data.firstname and data.lastname then
      updatename()
   else
      emitForm()
   end
else
   emitForm()
end


response:include"/rtl/.EmptyFooter.lsp"
?> 
