<?lsp
local fmt=string.format
local headercontent
if not page.rounded or cmsIsAdmin then
   local f = app.cmsdocs.open("rounded.txt", "rb")
   if f then
      page.rounded=f:read"*a"
      headercontent=page.rounded
      f:close();
   elseif cmsIsAdmin then
      headercontent="<p>You can create your own header by creating the following text file in your cmsdocs directory: rounded.txt</p>"
   else
      headercontent=""
   end
else
   headercontent=page.rounded
end


local function toHref(name,uri)
   return fmt("<a href='%s'>%s</a>\n",uri,name)
end

local function emitBlogLinks()
   print"<div class='leftcolbox'><div class='leftcolboxtop'></div>"
   if app.cats then
      if page.cats ~= app.cats then -- If categories updated
         page.cats = app.cats
         local t={}
         local uris=app.cats.uris
         for k,v in ipairs(app.cats.names) do
            table.insert(t, toHref(v, uris[k]))
         end
         page.catlinks=fmt("<div class='archives' id='archives'><h3 class='negative'>Categories</h3><pre>%s</pre></div>",table.concat(t))
      end
      print(page.catlinks)
   end
   print("<div class='archives' id='archives'><h3 class='negative'>Archives</h3><pre>")
   if page.archList ~= app.archList then -- If archive list updated
      page.archList = app.archList
      local t={}
      local month=cmsMonth
      for _,year in ipairs(app.archList) do
         local y = year.y
         table.insert(t,toHref(fmt("<b class='negative'>%s</b>",y),"/blog/"..y))
         for _,m in ipairs(year.m) do
            table.insert(t,toHref(month(m),fmt("/blog/%s/%s",y,m)))
         end
      end
      page.arch=table.concat(t)
   end
   write(page.arch,"</pre></div><br/></div>")
end

local function emitContent()
   if cmsBlog then
      local permalink,id,date,cat,subj,name,data=cmsBlog()
      while permalink do
         local pi = cmsPostedIn(cat)
         write("<div id='blogh'><h1><a href='",
                        permalink,
                        "'>",
                        subj,
                        "</a></h1><p>",
                        os.date(" %A, %B %dth, %Y ", date),
                        #name > 0 and (" by "..name) or "",
                        "</p></div>",
                        data,
                        "<p>",
                        pi and pi or "",
                        "</p>")
         local title,fbKey=cmsFbComments()
         if title then
            if fbKey then
               write'<a name="fbcomments"></a>'
               app.emitFbCommentBox(write,id,fbKey)
            else
               write("<p><a href='",permalink,"#fbcomments'>",title,"</a></p>")
            end
         end
         write"<div id='bloge'></div>"
         permalink,id,date,cat,subj,name,data=cmsBlog()
      end
   else
      cmsEmitPage()
   end
end


?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:fb="http://www.facebook.com/2008/fbml">
<head>
<title><?lsp=cmsTitle?></title>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<link rel="stylesheet" type="text/css" href="/theme/rounded.css" />
<?lsp=cmsHeader?>
<script src="/theme/rounded.js" type="text/javascript"></script>
</head>
<body>
<div id="wrapper">
<div id="top">
</div>
<div id="content">
<div id="header"><div id="headercontent"><?lsp=headercontent?></div></div>
<div id="menu">
<ul><?lsp print(app.links.li()) ?></ul>
<div style="padding-left:1em">
<?lsp if cmsIsBlog then emitBlogLinks() end ?>
</div>
</div>
<div id="InnerContent">
<?lsp if cmsShowAdmLinks then ?>
<div style="padding:3em;float:right"><div id="cmsManage"></div></div>
<?lsp 
end
emitContent()
?>
<br /><br />
</div>

<div id="footer">
<div class="left">
<?lsp
if cmsRssUri then
   write("<a id='feedurl' href='",cmsRssUri,"' title='Feed URL'><img src='/images/feedIcon.png' alt='RSS feed' style='border:none'/></a>")
end
if cmsIsAdmin then
   print[[<a href="/private/manage/" title="Configure the CMS">Configure</a>]]
elseif not cmsRssUri then
   print[[Powered by the <br/>FuguHub<br/>Web Server]]
end
?>
</div>
<div class="right">
FuguHub includes:
<a target="rtl" href="http://FuguHub.com/MxTunnel.lsp">HTTPS Tunnel</a>,
<a target="rtl" href="http://realtimelogic.com/products/barracuda-web-server/">Embedded Web Server</a>,
<a target="rtl" href="http://FuguHub.com/BulletinBoard.lsp">Bulletin Board</a>,
<a target="rtl" href="http://FuguHub.com/cms.lsp">Content Management System</a>,
<a target="rtl" href="http://FuguHub.com/blog.lsp">Blog Engine</a>,
<br/>
<a target="rtl" href="http://FuguHub.com/database.lsp">SQLite Database</a>,
<a target="rtl" href="http://FuguHub.com/FileServer.lsp">WebDAV Server</a>, and more.
</p>
</div>
</div>
</div>
<div id="bottom">
</div>
</div>
<?lsp cmsEmitGA() ?>
</body>
</html>
