#!/bin/sh

### BEGIN INIT INFO
# Provides:             FuguHub
# Required-Start:       $remote_fs $syslog
# Required-Stop:        $remote_fs $syslog
# Default-Start:        2 3 4 5
# Default-Stop:         0 6
# Short-Description:    Barracudadrive web server
### END INIT INFO
#
# description: FuguHub - advanced remote access.
# processname: FuguHub
# pidfile: /var/run/FuguHub.pid


# FuguHub user. Note: if you do change the username,
# change access on the BD directories to the correct UNIX user.

BDUSER=bd

# FuguHub home directory
export BDHOME=/home/bd
#BDHOME is used by the server for locating the home directory
export HOME=$BDHOME

#Web File Server home: The Web File Manager and WebDAV server root directory.
BDWFS=$BDHOME/disk

# Number of worker threads
BDTHREADS=3

# Max number of concurrent socket connections.
# Note: the default is set for extremely resource constrained systems.
BDCONNECTIONS=80


# Max number of concurrent login sessions. No upper limit except for
# memory limitations.
BDSESSIONS=100


#------------ End of configuration ----------------------------


DAEMON="$BDHOME/FuguHub -d  -u$BDUSER -h$BDHOME -r$BDWFS --threads $BDTHREADS --sessions $BDSESSIONS --connections $BDCONNECTIONS --pidfile FuguHub"

start() {
    echo "Starting FuguHub"
    cd $BDHOME
    $DAEMON
    RETVAL=$?
    echo
    return $RETVAL
}


stop() {
    start-stop-daemon -K -x $BDHOME/FuguHub
    rm -f /var/run/FuguHub.pid
    return 0
}

case "$1" in
    start)
        start
        ;;

    stop)
        stop
        ;;

    restart)
        stop
        start
        ;;

  *)
        echo "Usage: /etc/init.d/bdd {start|stop|restart}"
        exit 1
esac

exit 0
