<?lsp


local fmt=string.format

local data=request:data()
local http,https
if (data.http == "true" or
    data.http == "false") and
   (data.https == "true" or
    data.https == "false") then
   http = data.http == "true" and true or false
   https = data.https == "true" and true or false
else
   response:sendredirect"../protected/TestPortMapping.lsp"
   return
end

headerdata=[[
<script type="text/javascript" src="/rtl/jquery.js"></script>
<style type="text/css">
#faq span {
font-weight:bold;
}
#faq li {
margin: 1em;
}
</style>
<script type="text/javascript">
$(function()
{
   var prevThis;
   $("#faq span").css({borderBottom:"thin solid #ccc",cursor:"pointer"}).click(function() {
      if(prevThis && prevThis != this) $(prevThis).next().slideUp();
      prevThis = this;
      $(this).next().slideToggle();
   });
   $("#faq div").hide();
});
</script>
]]

function printStat(port)
   print(port and "Successful" or "Failed")
end


title="Port Mapping Failed"
response:include"../wizard/.header.lsp"

?>
<h1>Port Mapping Status</h1>
<table>
<tr><td>Port HTTP (80):</td><td><?lsp printStat(http) ?></td></tr>
<tr><td>Port HTTPS (443):</td><td><?lsp printStat(https) ?></td></tr>
</table>

<h1>Possible Problems</h1>

<p>The following is a list of possible problems listed in order of probability and how to solve the problems.<br/>Click the following links for solutions:</p>
<ul id="faq">
<?lsp
if http == false and https == false then
response:include".firewall.lsp"
response:include".upnp.lsp"
response:include".isp.lsp"
elseif http == false then
response:include".isp80.lsp"
response:include".upnp.lsp"
response:include".firewall.lsp"
elseif https == false then
response:include".isp443.lsp"
response:include".upnp.lsp"
response:include".firewall.lsp"
end
?>
</ul>

<h1>Actions</h1>
<ul>
<li>If your ISP blocks the port(s): <a href="../protected/SearchUPnP.lsp">Reconfigure port mapping</a> to use alternate ports (click advanced settings)</li>
<li><a href="../protected/TestPortMapping.lsp">Retest port mapping</a></li>
<li>Ignore error and continue with <a href="../protected/ddnsIntro.lsp">DDNS configuration</a></li>
</ul>

<?lsp
response:include"../wizard/.footer.lsp"
?>
