<?lsp

local fmt=string.format

local wanHttp, wanHttps = bd.ddns().wanPorts()
local igd = request:data("igd")
if igd then
   response:forward(".UPnPPortForward.lsp")
end

local dl = app.upnpdiscover(0)
local count=0
while not dl do
   dl = app.upnpdiscover(1000,true)
   count=count+1
   if count > 3 then break end
end

title= dl and "UPnP Enabled Router Found" or "Cannot find UPnP Enabled Router"
-- Make ".header" load our Wikipedia help engine
headerdata=[[
<script src="../help.js"></script>
<script type="text/javascript" src="/rtl/jquery.js"></script>
<script>
function showwait() {
      $("#content").html('<div style="width:180px;margin-left:auto;margin-right:auto;"><img src="/rtl/wfm-album/loading.gif"></div>');
};

onload = function(){
   $("#advancedBut").click(function(){
      $(this).remove();
      $('#advanced').fadeIn('fast');
   });
   $("input[type='submit']").click(function() {
      var http=$("#advanced tr td input[name='http']").attr("value");
      var https=$("#advanced tr td input[name='https']").attr("value");
      $("input[name='http']").attr("value", http);
      $("input[name='https']").attr("value", https);
   });
   $("#searchagain").click(function(){
      setTimeout("showwait();", 500);
      return true;
   });
};
</script>
]]
response:include"../wizard/.header.lsp"
?>
<h1><?lsp=title?></h1>
<?lsp if dl then ?>
<p><br/><p>
<div class="roundedbox bluebox" style="padding:2em;margin: auto;width: 30em;">
<table border="1" cellpadding="5">
<tr><th>Router IP address</th><th>Action</th></tr>
<?lsp
  local noOfIdgs=#dl
  if noOfIdgs == 1 then
     print("<p>Enable automatic UPnP Port Forwarding for FuguHub by pressing the button below.</p>")
  else
     print("<p>You have multiple UPnP enabled routers. Click one of the buttons below to enable Port Forwarding for FuguHub</p>")
  end
  for _,igd in ipairs(dl) do
     local ipAddr = string.match(igd,"http://([^/:]+)")
     if not ipAddr then
        ipAddr=igd
     end
     print(fmt("<tr><td>%s</td><td><form method='post'><input type='hidden' name='igd' value='%s'/><input type='hidden' name='http' value='80'/><input type='hidden' name='https' value='443'/><input type='submit' value='Enable Port Forwarding' /></form></td></tr>", ipAddr,igd))
  end
?>
</table>
<br/>
<a href="#" id="advancedBut">Advanced</a>

<table id="advanced" style="display:none;">
<tr><td>WAN HTTP port:</td><td><input type="text" size="4" name="http" value="<?lsp=wanHttp?>"/></td>
<td rowspan="2"><fieldset style="margin-left:1em"><legend>Note:</legend>Do not change the default values for HTTP(80) and HTTPS(443) unless your ISP blocks one or both ports.</fieldset></td>
</tr>
<tr><td>WAN&nbsp;HTTPS&nbsp;port:</td><td><input type="text" size="4" name="https" value="<?lsp=wanHttps?>"/></td></tr>
</table>

</div>
<?lsp else ?>
<p>You may have to search multiple times before your router is found. Would you like to <a id="searchagain" href="SearchUPnP.lsp">search again</a>?</p>

<p><b>Note:</b> Not all routers handle automatic port forwarding using UPnP. if you have enabled UPnP and FuguHub cannot find your router, check to see if there is an upgrade to your router's firmware. Call the tech support for your router if you cannot find an upgrade or cannot enable UPnP. Many routers ship with UPnP disabled and you must manually enable UPnP. Most routers include a small web-server that allows you to enable UPnP by using a browser.</p>

<?lsp

local gateways = app.getPrivGw()
local routers={}
local http=require"http"
local c=http.create{persistent=false}
for _,g in ipairs(gateways) do
   local ok,err=c:request{url=string.format("http://%s",g),method="GET"}
   if ok then -- If this is a web server i.e. a router
      table.insert(routers,g)
   end
end
if #routers > 0 then
local manyR = #routers > 1 and true or false
?>

<p>We have detected the following router<?lsp=manyR and "s" or""?>:</p>
<ul>
<?lsp
for _,r in ipairs(routers) do
  print(fmt("<li><a href='EnableUPnP.lsp?routerIP=%s'>%s</a></li>",r,r))
end
?>
</ul>

<p>Click<?lsp=manyR and " one of" or""?> the above link<?lsp=manyR and "s" or""?> to enable UPnP in your router.</p>

<?lsp else ?>

<p>Navigate to your router using another browser window. Login using your username and password. Look for a page in your router that allows you to enable UPnP. Consult your router documentation for more information.</p>

<p>Press the browser's refresh button on this page when you have enabled UPnP in your router.</p>

<?lsp end end?>

<p>You can alternatively continue with <a href="PortForward.lsp">manual port forwarding</a>.</p>

<?lsp
showAbort=true
response:include"../wizard/.footer.lsp"
?>
