<?lsp
local fmt=string.format
local io=bd.baseio

if request:method()=="POST" then
   for k,v in request:datapairs() do
      io:remove(fmt("/trace/bd.%s.txt",v))
   end
end


local t,l={},{}
local tinsert=table.insert
for name, isdir, mtime, size in io:files("/trace",true) do
   if not isdir then
      tinsert(l,mtime)
      t[mtime]={name,size}
   end
end
table.sort(l)


-- The extra header we need ".header" to add.
headerdata=[[
<link href="/rtl/fstab.css" rel="stylesheet" type="text/css" />
<script type='text/javascript' src='/rtl/wfm/wfm.js'></script>
<link href="../appmgr/style.css" rel="stylesheet" type="text/css" />
<style>
input.l { float:right }
</style>
<script type='text/javascript'>
window.sortList=[ [0,1] ];
$(function() {
   $("#selall").show().click(function() {
      $("input[name=name]").each(function() {
         this.checked = true;
      });
      $(this).blur();
      return false;
   });
});
</script>
]]
title="Menu: Administrator Panel: Trace files"
response:include"/rtl/.header.lsp"
?>
<h1>Trace files</h1>
<form method="post">
<div id="fstab">
<table>
<thead>
<tr><th>File name</th><th>Creation time</th><th>Size</th></tr>
</thead><tbody>
<?lsp

local function emit(k)
   local time=l[k]
   local x=t[time]
   local name=x[1]
   local size=x[2]
   response:write("<a href='ShowTrace.lsp?name=",
                  name,"'>",name,"</a></td><td>",
                  os.date("%H:%M %B %d %Y",time),"</td><td>",size)
   return name
end



local time=l[1]
local x=t[time]
response:write("<tr><td>")
emit(#l)
response:write("</td></tr>")
for k = (#l-1),1,-1 do
   response:write("<tr><td>")
   local name=emit(k)
   response:write("<input class='l' type='checkbox' name='name' value='",name:gsub("bd%.([^%.]+)%.txt","%1"),
                  "'/></td></tr>\n")
end
?>
</tbody>
</table>
</div>
<?lsp if #l > 1 then ?>
<input type="submit" id="selall" value="Select All" style="display:none" />
<input type="submit" value="Delete Selected" />
<?lsp end ?>
</form>
<?lsp
response:include"../.footer.lsp"
?>
