<?lsp

local sqlutil=require"sqlutil"
local function w(...) response:write(...) end 
local fmt=string.format

if request:method() == "POST" then
   local l={}
   local t={}
   local tinsert=table.insert
   for k,v in request:datapairs() do
      if k=="key" and not t[v] and tonumber(v) then
         tinsert(l,v)
         t[v]=true
      end
   end
   if #l>0 then
      local mailutil=require"mailutil"
      local sqlexec=mailutil.sqlexec
      conn:setautocommit("IMMEDIATE",15000)
      local mlkt=table.concat(l," or mailjobkey=")
      if sqlexec(conn,fmt("DELETE FROM maildownload WHERE (mailjobkey=%s)", mlkt)) and
         sqlexec(conn,fmt("DELETE FROM mailjobfile WHERE (mailjobkey=%s)", mlkt)) and
         sqlexec(conn,fmt("DELETE FROM mailjob WHERE (key=%s)", table.concat(l," or key="))) then
         conn:commit()
      else
         conn:rollback();
      end
      if t[jobkey] then -- Deleting current job
         mailutil.startjob(nil,nil,true) -- Abort current job
      end
   end
end

headerdata=[[
<link href="../../../fstab.css" rel="stylesheet" type="text/css" />
<style>
#activejob td{background:#B6D7EB}
</style>
<script type='text/javascript' src='/rtl/wfm/wfm.js'></script>
<script type='text/javascript'>
window.sortList=[ [0,1] ];
$(function() {
   $("#selall").show().click(function() {
      $("#fstab input[name=key]").each(function() {
         this.checked = true;
      });
      $(this).blur();
      return false;
   });
});
</script>
]]

local function safeEmailAddr(addr)
   return addr:gsub('[<>]',function(c) return c=='<' and '&lt;' or '&gt;' end)
end

local cnt=0
local function listjobs(cur)
   local key,bduser,subject,date = cur:fetch()
   if key then
      w'<form method="post"><div id="fstab"><table><thead><tr><th>Date</th><th>User</th><th>Subject</th><th>Action</th></tr></thead><tbody>'
      while key do
         cnt=cnt+1
         w('<tr',jobkey==key and ' id="activejob"' or '','><td><a href="?job=',key,'">',date,'</a></td><td>',bduser,'</td><td>',subject,'</td><td><input type="checkbox" name="key" value="',key,'"/></td></tr>')
         key,bduser,subject,date = cur:fetch()
      end
      w'</tbody></table></div><input type="submit" id="selall" value="Select All" style="display:none" /><input type="submit" name="deljob" value="Delete Selected" /></form>'
   end
end

local function tzone()
   local tzone=request:cookie"tzone"
   if tzone then
      tzone = tonumber(tzone:value())
      if tzone then return fmt("%d",tzone*60) end
   end
   return ""
end



local function emitJobInfo(jobkey,t)
   local exp = (not t.expires or t.expires == "0") and "Never" or os.date('%Y %B %d, %H:%M',tonumber(t.expires))
   local listkey=ba.json.decode(t.listkey)
   local success,failed=0,0
   if t.riop then
      local sql='count(*) FROM maildownload WHERE err IS%s NULL and mailjobkey='..jobkey
      success=tonumber(sqlutil.find(conn,fmt(sql,'')))
      failed=tonumber(sqlutil.find(conn,fmt(sql,' NOT')))
   end
?>
<div class="roundedbox">
<table>
<tr><td>Subject:</td><td><?lsp=t.subject?></td></tr>
<tr><td>Reply-To:</td><td><?lsp=safeEmailAddr(t.fromaddr)?></td></tr>
<?lsp 
if t.riop then w('<tr><td>Directory:</td><td>',t.riop,'</td></tr>') end
if not t.attach then
?>
<tr><td>Secure Connection:</td><td><?lsp=t.secure == "0" and "Not" or ""?> Required</td></tr>
<tr><td>Password:</td><td><?lsp=t.password == "0" and "Not" or ""?> Required</td></tr>
<tr><td>Link Exp:</td><td><?lsp=exp?></td></tr>
<?lsp if t.riop then ?>
<tr><td>Successful Downloads:</td><td><?lsp=success?></td></tr>
<tr><td>Failed Downloads:</td><td><?lsp=failed?></td></tr>
<?lsp end end ?>
</table>
<fieldset><legend>Recipients:</legend>
<?lsp
   if not t.tokey then _emit'<p><b>Sent to list(s):</b></p>' end
   _emit'<table><tr>'
   if t.tokey then -- Send to individual(s)
      local function action(to,l)
         for _,email in ipairs(l) do
            w('<tr><td>',to,'</td><td>',safeEmailAddr(email),'</td></tr>')
         end
      end
      action('To:',ba.json.decode(t.tokey))
      action('Cc:',listkey)
      action('Bcc:',ba.json.decode(t.groupkey))
   else
      local function action(cur)
         local name = cur:fetch()
         while name do
            w('<td><a href="list.lsp?name=',name,'">',name,'</a></td>')
            name = cur:fetch()
         end
      end
      sqlutil.select(conn,fmt("name from maillist where key in(%s)", table.concat(listkey,',')), action)
   end
   _emit'</tr></table></fieldset></div><p></p>'
   return success+failed
end -- function emitJobInfo



local function emitJobFiles(downloads,jobkey)
   local function action(cur)
      local key,name = cur:fetch()
      if downloads > 0 then
         while key do
            w('<tr><td><a href="',fmt('?job=%s&file=%s',jobkey,key),'">',name,'</a></td></tr>')
            key,name = cur:fetch()
         end
      else
         while key do
            w('<tr><td>',name,'</td></tr>')
            key,name = cur:fetch()
         end
      end
   end
   w'<div id="fstab"><table><thead><tr><th>Attached Links</th></tr></thead><tbody>'
   sqlutil.select(conn,"key,name from mailjobfile where mailjobkey="..jobkey,action)
   w'</tbody></table></div>'
end

local function emitAttachedFiles(files)
   if files then
      w'<div id="fstab"><table><thead><tr><th>Attached Files</th></tr></thead><tbody>'
      for _,file in ipairs(files) do
         w('<td>',file,'</td>')
      end
      w'</tbody></table></div>'
   end
end

local function emitJobFile(jobkey,filekey)
   local found=false
   local function action(cur)
      local email,ipaddr,date,err = cur:fetch()
      if email then
         found=true
         w'<div id="fstab"><table><thead><tr><th>Downloaded By</th><th>IP Address</th><th>Date</th><th>Status</th></tr></thead><tbody>'
         while email do
            w('<tr><td>',email,'</td><td>',ipaddr,'</td><td>',os.date('%Y %B %d, %H:%M',tonumber(date)),'</td><td>',err and "Failed" or "OK",'</td></tr>')
            email,ipaddr,date,err = cur:fetch()
         end
         w'</tbody></table></div><p></p>'
      end
   end
   sqlutil.select(conn,"(SELECT email FROM mailcontact WHERE key=mlkey),ipaddr,date,err FROM maildownload WHERE filekey="..filekey,action)
   if not found then
      w'<p>No downloads!</p>'
   end
   w('<form method="get"><input type="hidden" name="job" value="',jobkey,'"/><input type="submit" value="Return"/></form>')
   return true
end

local function emitJob(data)
   local jobkey=data.job
   if jobkey and tonumber(jobkey) then
      local t={}
      sqlutil.findt(conn,fmt(
         "%s%s","fromaddr,subject,txtbody,htmlbody,riop,tokey,listkey,groupkey,attach,secure,password,expires,batchkey FROM mailjob where key=",jobkey),t)
      if t.fromaddr then
         if data.file and tonumber(data.file) then
            return emitJobFile(jobkey,data.file)
         end
         local downloads=emitJobInfo(jobkey,t)
         if t.attach then
            emitAttachedFiles(ba.json.decode(t.attach))
         elseif t.riop then
            if t.tokey then
               if #ba.json.decode(t.tokey) == 1 and #ba.json.decode(t.listkey) == 0 and #ba.json.decode(t.groupkey) == 0 then
                  emitJobFiles(downloads,jobkey)
               end
            else
               emitJobFiles(downloads,jobkey)
            end
         end
         return true
      end
   end
end

function emitJobs(active)
   local data=request:data()
   if emitJob(data) then
      return 1
   end
   sqlutil.select(conn,fmt("%s(date%s,'unixepoch') FROM mailjob WHERE active=%s ORDER BY date", "key,bduser,subject,datetime",tzone(),active and 1 or 0),listjobs)
   return cnt
end

?>
