<?lsp

if not bd.mailbatchauth:authorize(request,"GET","") then
   response:sendredirect"./"
end

local sqlutil=require"sqlutil"
local mailutil=require"mailutil"
local quote=luasql.quotestr
local fmt=string.format
local env,conn = bd.openDb"bd"
local data=bd.trim(request:data())

local function listAction(cur)
   local key,name = cur:fetch()
   while key do
      response:write('<tr><td><input type="checkbox" name="del" value="',key,
                     '"/><a href="batch.lsp?key=',key,'">',name,'</a></td></tr>')
      key,name = cur:fetch()
   end
end

local function editJob(key,name,cmd)
headerdata=[[
<style>
#edit {width: 600px; margin:auto}
table, table input{width:100%;}
td.short {width:80px;}
</style>
]]
title="Menu: Mail Manager: Batch Jobs: "..(key and "Edit" or "New")
response:include"/rtl/.header.lsp"

?>
<div class="roundedbox" id="edit">
   <form method="post">
     <?lsp= key and fmt('<input type="hidden" name="key" value="%s"/>',key) or "" ?>
     <table>
       <tr><td class="short">Job Name:</td><td><input type="text" name="name" value="<?lsp=name or ''?>"/></td></tr>
       <tr><td class="short">Command:</td><td><input type="text" name="cmd" value="<?lsp=cmd or ''?>"/></td></tr>
     </table>
     <input type="submit" name="save" value="Save"/>
     <input type="submit" name="cancel" value="Cancel"/>
   </form>
</div>
<?lsp   
end


local function listJobs()
headerdata=[[
<link href="../../../fstab.css" rel="stylesheet" type="text/css" />
<style>
input[type=checkbox] {margin-right:10px;}
</style>
<script type='text/javascript' src='/rtl/wfm/wfm.js'></script>
]]
title="Menu: Mail Manager: Batch Jobs"
response:include"/rtl/.header.lsp"
?>
<h1>Batch Jobs</h1><br/>
<form method="post">
<div id='fstab'>
<table>
<thead>
<tr><th>Batch Job Name</th></tr>
</thead>
<tbody>
<?lsp sqlutil.select(conn,'key,name FROM mailbatchjob', listAction) ?>
</tbody>
</table>
</div>
<br/>
<table><tr>
<td><input type="submit" name="new" value="Create New Job"/></td>
<td><input type="submit" name="delsel" value="Delete Selected Jobs"/></td>
</tr></table>
</form>
<?lsp end ?>

<?lsp
if data.save then
   if data.name and #data.name > 0 and data.cmd and #data.cmd > 0 then
      local sql
      if data.key then
         if tonumber(data.key) then
            sql=fmt("UPDATE mailbatchjob SET name=%s,cmd=%s WHERE key=%s",quote(data.name),quote(data.cmd),data.key)
         end
      else
         sql=fmt("INSERT INTO mailbatchjob (name,cmd) VALUES (%s,%s)",quote(data.name),quote(data.cmd))
      end
      if sql then
         mailutil.sqlexec(conn,sql) 
      end
   end
elseif data.new then
   editJob()
elseif data.delsel then
   local tinsert=table.insert
   local l={}
   for k,v in request:datapairs() do
      if k=="del" and tonumber(v) then
         tinsert(l,v)
      end
   end
   if #l>0 then
      local sql=fmt("DELETE FROM mailbatchjob WHERE (key=%s)", table.concat(l," or key="))
      mailutil.sqlexec(conn,sql)
   end
else
   local name,cmd
   if data.key and tonumber(data.key) then
      name,cmd=sqlutil.find(conn,"name,cmd from mailbatchjob WHERE key="..data.key)
   end
   if name then
      editJob(data.key,name,cmd)
   else
      listJobs()
   end
end
bd.closeDb(env,conn)
if request:method()=="POST" and not data.new then
   response:sendredirect"batch.lsp"
end
response:include".footer.lsp"
?>
