<?lsp

local fmt=string.format

headerdata=[[
<style>
p {text-align:center}
input {margin:auto;width:150px;padding:5px;font-size:26px;font-weight:bold}
#yes {color:blue}
#no {color:red;}

</style>
]]
title="Menu: Mail Manager: Delete List"
response:include"/rtl/.header.lsp"

local env,conn = bd.openDb"bd"
local function closeDb(uri)
   bd.closeDb(env,conn)
   if uri then
      response:sendredirect(uri)
   end
end

local function sqlexec(sql)
   local ok,e1,e2=conn:execute(sql)
   if not ok then
      trace("SQL maillist err:",sql," : ",e1,e2)
   end
   return ok
end


local data=request:data()
local listkey,size
if data.name then
   local sqlutil=require"sqlutil"
   listkey=sqlutil.find(conn,"key FROM maillist WHERE name="..luasql.quotestr(data.name))
   if listkey then
      size=tonumber(sqlutil.find(conn,"count(*) FROM mailcontact WHERE listkey="..listkey))
   end
end

if not listkey then
   closeDb("lists.lsp")
end
if data.delete then
   if data.delete =="Yes" then
      conn:setautocommit("IMMEDIATE",1000)
      if sqlexec(fmt("DELETE FROM maillist WHERE key=%s;",listkey)) and
         sqlexec(fmt("DELETE FROM mailcontact WHERE listkey=%s",listkey)) and
         sqlexec(fmt("DELETE FROM mailsubgroup WHERE listkey=%s;",listkey)) then
         conn:commit();
      else
         conn:rollback();
      end
   end
   closeDb("lists.lsp")
end

?>
<div class="roundedbox" id="menu">
   <form method="post">
   <h1>Delete List: <?lsp=data.name?>
   <p>Delete <?lsp= size == 1 and "one contact" or fmt("%s contacts",size) ?>?</p>
   <input type="hidden" name="name" value="<?lsp=data.name?>"/>
   <input type="submit" id="no" name="delete" value="No"/>
   <input type="submit" id="yes" name="delete" value="Yes"/>
   </form>
</div>
<?lsp 

?>
<?lsp
closeDb()
response:include".footer.lsp"
?>
