<?lsp

local emails = request:data"emails"
local found
local removed=0
if emails then
   found={}
   local tinsert=table.insert
   for l in string.gmatch(emails, "[^\n]+") do
      local e=l:match("[^%s]-@[^^%s]+")
      if e then
         tinsert(found,e)
      end
   end
   if #found > 0 then
      local mailutil=require"mailutil"
      local sqlexec=mailutil.sqlexec
      local sqlutil=require"sqlutil"
      local q=luasql.quotestr
      local env,conn = bd.openDb"bd"
      local before = sqlutil.find(conn,"COUNT(*) from mailcontact")
      conn:setautocommit("IMMEDIATE",15000)
      for _,v in ipairs(found) do
         sqlexec(conn,"DELETE FROM mailcontact WHERE email="..q(v))
      end
      conn:commit()
      local after = sqlutil.find(conn,"COUNT(*) from mailcontact")
      before = before and tonumber(before)
      after = after and tonumber(after)
      if before and after then removed = before - after end
      bd.closeDb(env,conn) 
   end
end

headerdata=[[
<style>
#emails { max-width:380px; margin:auto; }
#emails textarea { width:100%; height:400px}
#content {background: #F0F0F0;}
</style>
]] 
title="Menu: Mail Manager: Remove Contacts"
response:include"/rtl/.header.lsp"
?>
<h1>Remove Contacts</h1>
<div id="emails">
<?lsp
if found then
   response:write("<p><b>Emails entered: ",#found,"</b></p><ul>")
   for _,v in ipairs(found) do
      response:write("<li>",v,"</li>")
   end
   response:write("</ul><p><b>Emails removed: ",removed,"</b></p><p><a href='remove.lsp'>Continue</a></p>")
else
?>
<form method="post">
<textarea placeholder="Enter or paste multiple email addresses into this text area." name="emails"></textarea>
<input type="submit" value="Remove Contacts"/>
</form>
<?lsp end ?>
</div>
<?lsp response:include".footer.lsp" ?>
