<?lsp

data=bd.trim(request:data())
response:include".jobhistory.lsp"
headerdata=headerdata..[[
<style>
textarea {width:100%;height:320px;}
#subject{width:100%;border-collapse:collapse}
input[type=submit] { min-width:100px;height:30px;}
#selaction {display:none}
p.err{font-weight:bold;color:red}
</style>
]]
response:include".header.lsp"
if not email.settings then response:sendredirect"prepare.lsp" end

local errmsg
local fmt=string.format
local defsub = (#email.files > 1 and string.format("Download %s files",#email.files) or "Download "..(email.files[1] or ""))
local subject = data.subject and #data.subject > 0 and data.subject or nil
if data.back then
   email.subject=subject
   email.body=data.body and #data.body > 0 and data.body or nil
   response:sendredirect"prepare.lsp"
end
subject = subject or email.subject or ""

if data.body and data.subject then
   local mailutil=require"mailutil"
   subject = #data.subject > 0 and data.subject or subject
   local function x(x) return x end
   local body,foundT=mailutil.expandmacros(
      data.body, {
         LINK=x,
         FIRSTNAME=x,
         LASTTNAME=x,
         NAME=x,
      }
   )
   if email.individual then
      for k,v in pairs(foundT) do
         if k ~= "LINK" then
            errmsg = fmt("Cannot use macro [%s] %s",k,"when sending to individual(s)!")
            break
         end
      end
   end

   if not errmsg then
      if email.settings.attach then
         if foundT.LINK then
            errmsg = "Cannot use macro [LINK] with attached files!"
         end
      else
         if foundT.LINK ~= 1 then
            if foundT.LINK then
               errmsg="The email body cannot contain more than one [LINK] macro!"
            else
               errmsg="Macro [LINK] required when sending links!"
            end
         end
      end
   end

   if not errmsg then
      email.body=data.body
      if #subject > 0 then
         email.subject=subject
      else
         email.defsub=defsub
      end
      local ok
      ok,errmsg=mailutil.startjob(request:user(),email)
      if ok then response:sendredirect"close.lsp" end
   end
end

local function mkTemplate()
   return fmt("%s%s",
              email.list and "Hello [FIRSTNAME]\n" or "",
              email.settings.attach and "" or "\nDownload by clicking:\n[LINK]\n")
end

local env,conn=bd.openDb"bd"
if data.jobkey and tonumber(data.jobkey) then
   local sub,txtbody,htmlbody=require"sqlutil".find(
      conn,
      "subject,txtbody,htmlbody FROM mailjob where key="..data.jobkey)
   if sub then
      email.subject=sub
      subject=sub
      email.body = #txtbody > 0 and txtbody or htmlbody
   end
end
local body = data.body or email.body or mkTemplate()
if not errmsg then emitHistory(conn) end
?>
<p class="err"><?lsp=errmsg or ""?></p>
<form method="post">
<table id="subject"><tr>
<td style="width:55px;">Subject: </td>
<td><input style="width:100%" type="text" id="subject" name="subject" value="<?lsp=subject?>" placeholder="<?lsp=defsub?>"/></td>
</tr></table>
<textarea name="body"><?lsp=body?></textarea>
<input type="submit" name="send" value="Send Email"/>
<input type="submit" name="back" value="Back"/>
</form>
</body>
</html>
<?lsp bd.closeDb(env,conn) ?>
